{{ Hash Code Command Interpeter by Bill Drummond
This program is a demonstration of using hash codes to parse keyboard input into commands.

Using hash codes makes the case statment easy to use and to my eye code that's easier to follow than 'if else' code.
The Windows Program HashPrj.exe will output the Constants to a text file that you can cut and paste for the commands
you wish to use.

I've include code for 0 to 2 argument strings.

A web search turned this link up:  
http://www.partow.net/programming/hashfunctions/index.html
}}
CON

        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000


 
 COPY = $00048459
 DEL = $0000489C
 DIR = $000048E2
 HELP = $0004CA10
 MOUNT = $00524A34
 TYPE = $00059E45
 UNMOUNT = $0A324A64
OBJ

        term    : "tv_terminal"
        kb      : "keyboard"

VAR
 long  x
 byte HashStr[32]
 byte Arg1[12]
 byte Arg2[12]
 byte HasArgs
 Byte Has2Args
PUB start | i

  'start the tv terminal
  term.start(12)
  term.str(string("HashCode Demo...",13))

  'start the keyboard
  kb.start(26, 27)
  
  HashStr := String("DIR")
  Hash(@HashStr)
  repeat
   term.str(string(13,"Enter a Command >"))
    DoCmd(Hash(getCmd))
   
  
      
PUB DoCmd(Cmd)
  Term.out("$")
  Term.Hex(Cmd,8)
  case Cmd
   COPY   : term.str(string(" = COPY Command",13))
            if HasArgs
              term.str(GetArg1)
            if Has2Args
              Term.str(GetArg2) 
   DEL    : term.str(string(" = DEL Command",13))
            if HasArgs
              term.str(GetArg1)
   DIR    : term.str(string(" = DIR Command",13)) 
   HELP   : term.str(string(" = HELP Command",13)) 
   MOUNT  : term.str(string(" = MOUNT Command",13)) 
   TYPE   : term.str(string(" = TYPE Command",13))
            if HasArgs
              term.str(GetArg1)
            
   UNMOUNT: term.str(string(" = UNMOUNT Command",13))
   OTHER  : term.str(string(" =  Unrecognized Command",13))
  
PUB GetCmd : Str_Ptr| i,ch 
    i := 0
    repeat until ch == 13
      ch  := UpperCase(kb.getkey)
      HashStr[i++] := ch
      term.out(ch)
   HashStr[i-1] := 0
   return @HashStr
   
PUB GetArg1 : Str_Ptr | j,i,ch
    i := 0
    j := 0
    Has2Args := 0
    repeat until HashStr[i] == $20
      i++
    i ++
    repeat until HashStr[i] == 0 
     Arg1[j] := HashStr[i]
      if HashStr[i] == $20
       Has2Args := -1
       quit
      i++
      j++
    Arg1[i] := 0
    Return @Arg1
    
PUB GetArg2 : Str_Ptr | j,i,ch
    i := 0
    j := 0
    repeat until HashStr[i] == $20
      i++
    i ++
    repeat until HashStr[i] == $20
      i++
    i ++
    repeat until HashStr[i] == 0 
     Arg2[j] := HashStr[i]
      i++
      j++
    Arg2[i] := 0
    Return @Arg2
    
PUB Hash(string_ptr) : Result
  HasArgs := 0
  repeat while (byte[string_ptr] <> 0  ) 
    if  byte[string_ptr] == $20
     HasArgs := -1
     quit
   Result := (Result << 4) + byte[string_ptr++] 
   x := Result & $F0_00_00_00
   if (x <> 0)
    Result := Result ^ (x >> 24)
   Result := result & (! x)
   
PRI uppercase(c) : chr

  if lookdown(c: "a".."z")
    c -= $20
  chr := c

  {{

                                                   TERMS OF USE: MIT License                                                                                                              

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
}}